<script>
import axios from '../axios'
import ProfileOrders from "./ProfileOrders.vue";
import ShoppingCart from "./ShoppingCart.vue";
import Favourites from "./ProfileFavourites.vue";
import Notifications from "./ProfileNotifications.vue";

export default {
    name: "ProfileLayout",
    components: { ProfileOrders, ShoppingCart, Favourites, Notifications },
    data() {
        return {
            user: JSON.parse(localStorage.user),
            loading: true,
            tab: this.$route.params.tab ?? 'orders',
            type: this.$route.params.type,
            selectedItem: {},
            action: 1,
            countPerson: 1,
            isEdit: false,
            hasError: {
                editProfile: null
            }
        }
    },
    methods: {
        saveProfile() {
            this.isEdit = !this.isEdit;

            axios.post('/api/auth/edit-profile', {
                id: this.user.id,
                email: this.user.email,
                phone: this.user.phone,
                name: this.user.name
            }).then(({data}) => {
                if (data.success) {
                    localStorage.user = JSON.stringify(this.user)
                    window.location.reload()
                }
            }).catch(error => {
                this.hasError.editProfile = error.response.data.message;
            });
        },
        pay(price, item) {
            axios.post('/api/payment/buy', {
                price: price,
                item: item,
            }).then(({data}) => {
                this.getData();
                window.open(data)
            })
        },
        openLink(link) {
            window.open(link)
        },
        formatPrice(price) {
            return Math.round(fx(price).from("RUB").to("EUR"))
        },
        logout() {
            localStorage.clear()
            this.$router.push({name: 'Home'}).then(() => {
                window.location.reload();
            });
        }
    },
    watch: {
        '$route.params': {
            handler(params) {
                this.tab  = params.tab  || 'orders';
                this.type = params.type || 'all';
            },
            immediate: true
        }
    }
}
</script>

<template>
    <main class="main__profile orders">
        <div class="profile__container">
            <div class="profile">
                <div class="profile-has-error" v-if="hasError.editProfile">{{ this.hasError.editProfile }}</div>
                <div class="profile__top">
                    <div class="profile__info">
                        <div class="profile__user">
                            <img src="../img/icons/avatar.svg" alt="avatar">
                            <template v-if="!isEdit">
                                <span>{{user.name}}</span>
                            </template>
                            <template v-else>
                                <input class="form_in" type="text" placeholder="NAME" v-model="user.name" style="margin-top: 27px;">
                            </template>
                        </div>
                        <div class="profile__email">
                            <div class="profile__label">
                                Email
                            </div>
                            <template v-if="!isEdit">
                                <div class="profile__text">
                                    {{user.email}}
                                </div>
                            </template>
                            <template v-else>
                                <input class="form_in" type="text" placeholder="EMAIL" v-model="user.email">
                            </template>
                        </div>
                        <div class="profile__phone">
                            <div class="profile__label">
                                Phone number
                            </div>
                            <template v-if="!isEdit">
                                <div class="profile__text">
                                    {{user.phone}}
                                </div>
                            </template>
                            <template v-else>
                                <input class="form_in" type="text" placeholder="PHONE" v-model="user.phone">
                            </template>
                        </div>
                        <template v-if="isEdit">
                            <a class="save-edit" @click="saveProfile">Save</a>
                        </template>
                    </div>
                    <div class="profile__edit">
                        <button class="profile__edit--btn" @click="isEdit = !isEdit">
                            <img src="../img/icons/edit-profile.svg" alt="edit-profile">
                        </button>
                    </div>
                </div>
                <div class="profile__content" v-show="action === 1">
                    <div class="sidebar sidebar-noacc">
                        <div class="sidebar__menu">
                            <router-link :to="{ name: 'Profile', params: { tab: 'orders', type: type } }" class="sidebar__menu--item"
                                         :class="{active: tab === 'orders'}">
                                <svg width="30" height="30" viewBox="0 0 30 30" fill="none" xmlns="http://www.w3.org/2000/svg">
                                    <path d="M7.34457 9.68388C7.34457 9.07883 7.34457 8.51412 7.34457 7.94941C7.34457 7.3242 7.45305 6.71915 7.75679 6.17461C8.40768 5.00485 9.4057 4.27879 10.7943 4.05694C13.0507 3.69391 15.1552 5.10569 15.5457 7.18302C15.5891 7.44521 15.6108 7.70739 15.6108 7.96958C15.6108 8.53429 15.6108 9.07883 15.6108 9.66371C15.6976 9.66371 15.7627 9.66371 15.8278 9.66371C16.2183 9.66371 16.6305 9.66371 17.0211 9.68388C17.6719 9.74439 18.1276 10.2083 18.171 10.8133C18.2577 12.1646 18.3228 13.5159 18.4096 14.847C18.4096 14.9478 18.3662 15.0688 18.3228 15.1495C18.1493 15.4117 17.9757 15.6739 17.7804 15.9562C17.5418 15.7545 17.3248 15.573 17.1078 15.4117C16.1532 14.6251 15.0467 14.3629 13.81 14.6049C12.4649 14.8671 11.315 15.9965 11.098 17.247C10.881 18.5176 11.2933 19.5865 12.3347 20.4336C13.6148 21.4823 14.8731 22.5311 16.1532 23.5798C16.8258 24.1244 17.6069 24.4269 18.4964 24.447C18.6483 24.447 18.8001 24.447 18.952 24.447C19.169 25.1731 18.6266 25.9193 17.8021 26C17.7153 26 17.6502 26 17.5635 26C13.5063 26 9.47079 26 5.41361 26C4.67594 26 4.15523 25.637 4.02505 25.0319C3.98166 24.8101 4.00336 24.5479 4.02505 24.3059C4.17693 21.7647 4.3288 19.2235 4.48067 16.6621C4.58915 14.7259 4.69763 12.81 4.82781 10.8738C4.8712 10.1276 5.41361 9.64355 6.21636 9.62338C6.6069 9.62338 6.97573 9.62338 7.38796 9.62338L7.34457 9.68388ZM13.2025 9.68388C13.2025 9.01833 13.2242 8.37295 13.2025 7.72756C13.1808 7.12251 12.812 6.67881 12.2262 6.39646C11.2065 5.91242 9.86132 6.59814 9.79623 7.64689C9.75284 8.29227 9.77454 8.95783 9.77454 9.62338C9.77454 9.64355 9.77454 9.66371 9.79623 9.68388H13.2242H13.2025Z" fill="#207FBF"/>
                                    <path d="M18.38 19.1962C18.38 19.1962 18.4476 19.0946 18.4928 19.0539C19.9364 16.9604 21.4025 14.8872 22.8461 12.7937C23.207 12.2652 23.7258 11.9807 24.4476 12.001C25.5754 12.0417 26.3423 13.1799 25.8461 14.0945C25.598 14.5417 25.2822 14.9482 24.989 15.375C23.41 17.6515 21.8311 19.9279 20.2521 22.184C19.9138 22.6515 19.4852 22.9564 18.8537 22.997C18.4476 23.0173 18.0642 22.936 17.7484 22.6921C17.0266 22.1433 16.3499 21.5742 15.6281 21.0255C14.9514 20.497 14.2747 19.9482 13.6206 19.4198C12.9213 18.8506 12.8086 18.0173 13.3048 17.3669C13.9138 16.6149 15.0191 16.5132 15.8311 17.1636C16.6431 17.7937 17.4326 18.4441 18.2446 19.0742C18.2897 19.1149 18.3349 19.1352 18.4025 19.1759L18.38 19.1962Z" fill="#207FBF"/>
                                </svg>
                                Orders
                            </router-link>
                            <router-link :to="{ name: 'Profile', params: { tab: 'cart', type: type } }" class="sidebar__menu--item"
                                         :class="{active: tab === 'cart'}">
                                <svg width="30" height="30" viewBox="0 0 30 30" fill="none" xmlns="http://www.w3.org/2000/svg">
                                    <path d="M4.5 1.5C4.10218 1.5 3.72064 1.65804 3.43934 1.93934C3.15804 2.22064 3 2.60218 3 3C3 3.39782 3.15804 3.77936 3.43934 4.06066C3.72064 4.34196 4.10218 4.5 4.5 4.5H6.33L6.7875 6.333C6.79204 6.35411 6.79705 6.37511 6.8025 6.396L8.8395 14.541L7.5 15.879C5.61 17.769 6.948 21 9.621 21H22.5C22.8978 21 23.2794 20.842 23.5607 20.5607C23.842 20.2794 24 19.8978 24 19.5C24 19.1022 23.842 18.7206 23.5607 18.4393C23.2794 18.158 22.8978 18 22.5 18H9.621L11.121 16.5H21C21.2785 16.4999 21.5514 16.4222 21.7883 16.2757C22.0251 16.1292 22.2165 15.9196 22.341 15.6705L26.841 6.6705C26.9552 6.44187 27.0092 6.18784 26.9977 5.93251C26.9862 5.67718 26.9096 5.42903 26.7753 5.21159C26.641 4.99416 26.4533 4.81465 26.2301 4.69012C26.0069 4.56558 25.7556 4.50014 25.5 4.5H9.42L8.955 2.6355C8.87374 2.31113 8.68643 2.02321 8.42281 1.81748C8.15919 1.61175 7.83439 1.50001 7.5 1.5H4.5ZM24 24.75C24 25.3467 23.7629 25.919 23.341 26.341C22.919 26.7629 22.3467 27 21.75 27C21.1533 27 20.581 26.7629 20.159 26.341C19.7371 25.919 19.5 25.3467 19.5 24.75C19.5 24.1533 19.7371 23.581 20.159 23.159C20.581 22.7371 21.1533 22.5 21.75 22.5C22.3467 22.5 22.919 22.7371 23.341 23.159C23.7629 23.581 24 24.1533 24 24.75ZM9.75 27C10.3467 27 10.919 26.7629 11.341 26.341C11.7629 25.919 12 25.3467 12 24.75C12 24.1533 11.7629 23.581 11.341 23.159C10.919 22.7371 10.3467 22.5 9.75 22.5C9.15326 22.5 8.58097 22.7371 8.15901 23.159C7.73705 23.581 7.5 24.1533 7.5 24.75C7.5 25.3467 7.73705 25.919 8.15901 26.341C8.58097 26.7629 9.15326 27 9.75 27Z" fill="#207FBF"/>
                                </svg>
                                Shopping Cart
                            </router-link>
                            <router-link :to="{name: 'Profile', params: { tab: 'favourites', type: type } }" class="sidebar__menu--item"
                                         :class="{active: tab === 'favourites'}">
                                <svg width="30" height="30" viewBox="0 0 30 30" fill="none" xmlns="http://www.w3.org/2000/svg">
                                    <path d="M15 24L13.55 22.7052C8.4 18.1243 5 15.0932 5 11.3951C5 8.36403 7.42 6 10.5 6C12.24 6 13.91 6.79455 15 8.04033C16.09 6.79455 17.76 6 19.5 6C22.58 6 25 8.36403 25 11.3951C25 15.0932 21.6 18.1243 16.45 22.7052L15 24Z" fill="#207FBF"/>
                                </svg>
                                Favourite
                            </router-link>
                            <router-link :to="{name: 'Profile', params: { tab: 'notifications' }}" class="sidebar__menu--item"
                                         :class="{active: tab === 'notifications'}">
                                <svg width="30" height="30" viewBox="0 0 30 30" fill="none" xmlns="http://www.w3.org/2000/svg">
                                    <path d="M14.9999 27.5C16.3749 27.5 17.4999 26.375 17.4999 25H12.4999C12.4999 25.663 12.7633 26.2989 13.2322 26.7678C13.701 27.2366 14.3369 27.5 14.9999 27.5ZM22.4999 20V13.75C22.4999 9.9125 20.4499 6.7 16.8749 5.85V5C16.8749 3.9625 16.0374 3.125 14.9999 3.125C13.9624 3.125 13.1249 3.9625 13.1249 5V5.85C9.53744 6.7 7.49994 9.9 7.49994 13.75V20L5.88744 21.6125C5.09994 22.4 5.64994 23.75 6.76244 23.75H23.2249C24.3374 23.75 24.8999 22.4 24.1124 21.6125L22.4999 20Z" fill="#207FBF"/>
                                    <circle cx="23" cy="4" r="2" fill="#E30016"/>
                                </svg>
                                Notifications
                            </router-link>
                        </div>
                        <div class="sidebar__logout">
                            <a class="logout" @click="logout">
                                Log out of profile
                                <img src="../img/icons/ion_exit.svg" alt="exit">
                            </a>
                        </div>
                    </div>
                    <div class="profile__back">
                        <router-link :to="{name: 'Home'}">
                            Back
                        </router-link>
                    </div>
                    <div class="profile__content--title">
                        <svg width="30" height="30" viewBox="0 0 30 30" fill="none" xmlns="http://www.w3.org/2000/svg">
                            <path d="M7.34457 9.68388C7.34457 9.07883 7.34457 8.51412 7.34457 7.94941C7.34457 7.3242 7.45305 6.71915 7.75679 6.17461C8.40768 5.00485 9.4057 4.27879 10.7943 4.05694C13.0507 3.69391 15.1552 5.10569 15.5457 7.18302C15.5891 7.44521 15.6108 7.70739 15.6108 7.96958C15.6108 8.53429 15.6108 9.07883 15.6108 9.66371C15.6976 9.66371 15.7627 9.66371 15.8278 9.66371C16.2183 9.66371 16.6305 9.66371 17.0211 9.68388C17.6719 9.74439 18.1276 10.2083 18.171 10.8133C18.2577 12.1646 18.3228 13.5159 18.4096 14.847C18.4096 14.9478 18.3662 15.0688 18.3228 15.1495C18.1493 15.4117 17.9757 15.6739 17.7804 15.9562C17.5418 15.7545 17.3248 15.573 17.1078 15.4117C16.1532 14.6251 15.0467 14.3629 13.81 14.6049C12.4649 14.8671 11.315 15.9965 11.098 17.247C10.881 18.5176 11.2933 19.5865 12.3347 20.4336C13.6148 21.4823 14.8731 22.5311 16.1532 23.5798C16.8258 24.1244 17.6069 24.4269 18.4964 24.447C18.6483 24.447 18.8001 24.447 18.952 24.447C19.169 25.1731 18.6266 25.9193 17.8021 26C17.7153 26 17.6502 26 17.5635 26C13.5063 26 9.47079 26 5.41361 26C4.67594 26 4.15523 25.637 4.02505 25.0319C3.98166 24.8101 4.00336 24.5479 4.02505 24.3059C4.17693 21.7647 4.3288 19.2235 4.48067 16.6621C4.58915 14.7259 4.69763 12.81 4.82781 10.8738C4.8712 10.1276 5.41361 9.64355 6.21636 9.62338C6.6069 9.62338 6.97573 9.62338 7.38796 9.62338L7.34457 9.68388ZM13.2025 9.68388C13.2025 9.01833 13.2242 8.37295 13.2025 7.72756C13.1808 7.12251 12.812 6.67881 12.2262 6.39646C11.2065 5.91242 9.86132 6.59814 9.79623 7.64689C9.75284 8.29227 9.77454 8.95783 9.77454 9.62338C9.77454 9.64355 9.77454 9.66371 9.79623 9.68388H13.2242H13.2025Z" fill="#207FBF"/>
                            <path d="M18.38 19.1962C18.38 19.1962 18.4476 19.0946 18.4928 19.0539C19.9364 16.9604 21.4025 14.8872 22.8461 12.7937C23.207 12.2652 23.7258 11.9807 24.4476 12.001C25.5754 12.0417 26.3423 13.1799 25.8461 14.0945C25.598 14.5417 25.2822 14.9482 24.989 15.375C23.41 17.6515 21.8311 19.9279 20.2521 22.184C19.9138 22.6515 19.4852 22.9564 18.8537 22.997C18.4476 23.0173 18.0642 22.936 17.7484 22.6921C17.0266 22.1433 16.3499 21.5742 15.6281 21.0255C14.9514 20.497 14.2747 19.9482 13.6206 19.4198C12.9213 18.8506 12.8086 18.0173 13.3048 17.3669C13.9138 16.6149 15.0191 16.5132 15.8311 17.1636C16.6431 17.7937 17.4326 18.4441 18.2446 19.0742C18.2897 19.1149 18.3349 19.1352 18.4025 19.1759L18.38 19.1962Z" fill="#207FBF"/>
                        </svg>
                        Shopping Cart
                    </div>
                    <div class="orders">
                        <div class="orders__tabs" v-if="tab !== 'notifications'">
                            <ul class="nav nav-tabs" id="myTab" role="tablist">
                                <li class="nav-item" role="presentation">
                                    <router-link class="nav-link" :to="{ name: 'Profile', params: { tab: tab, type: 'all' } }"
                                        :class="{active: type === 'all'}">
                                        All
                                    </router-link>
                                </li>
                                <li class="nav-item" role="presentation">
                                    <router-link class="nav-link" :to="{ name: 'Profile', params: { tab: tab, type: 'flights' } }"
                                        :class="{active: type === 'flights'}" to>
                                        Flights
                                    </router-link>
                                </li>
                                <li class="nav-item" role="presentation">
                                    <router-link class="nav-link" :to="{ name: 'Profile', params: { tab: tab, type: 'hotels' } }"
                                        :class="{active: type === 'hotels'}" to>
                                        Hotels
                                    </router-link>
                                </li>
                            </ul>
                        </div>

                        <ProfileOrders v-if="tab === 'orders'" @update:selectedItem="selectedItem = $event"
                                       @update:action="action = $event" :key="tab"/>
                        <ShoppingCart v-if="tab === 'cart'" @update:selectedItem="selectedItem = $event"
                                      @update:action="action = $event" :key="tab"/>
                        <Favourites v-if="tab === 'favourites'" @update:selectedItem="selectedItem = $event"
                                    @update:action="action = $event" :key="tab"/>
                        <Notifications v-if="tab === 'notifications'" @update:selectedItem="selectedItem = $event"
                                       @update:action="action = $event" :key="tab"/>

                    </div>
                </div>
                <div v-show="action === 2" class="profile__content">
                    <div style="width: 100%">
                        <div class="profile__info" style="flex-direction: column; padding: 25px;">
                            <div class="block_f" v-if="Object.keys(selectedItem).length !== 0">
                                <div class="orders__item orders__flights">
                                    <div class="orders__flights--top">
                                        <div class="orders__flights--left">
                                            <div class="orders__flights--info">
                                                <div class="orders__flights--name">
                                                    {{selectedItem.depCity.title}} - {{selectedItem.arriveCity.title}}
                                                </div>
                                                <div class="orders__flights--text">
                                                    {{selectedItem.duration.flight.hour}} h, {{selectedItem.duration.flight.minute}} min on the way
                                                </div>
                                            </div>
                                            <div class="orders__flights--airlines">
                                                <img src="../img/images/airlines.png" alt="airlines">
                                                <span>{{selectedItem.provider.supplier.title}}</span>
                                            </div>
                                        </div>
                                        <div class="orders__flights--right">
                                            <div class="orders__flights--price">
                                                <button class="cart">
                                                    <img src="../img/icons/cart-disable.svg" alt="cart">
                                                </button>
                                                {{ formatPrice(selectedItem.price) }} €
                                            </div>
                                            <div class="orders__flights--more">
                                                Baggage <span>+50 €</span>
                                                <div class="check"></div>
                                            </div>
                                        </div>
                                    </div>
                                    <div class="orders__flights--way">
                                        <div class="way">
                                            <div class="way__left">
                                                <div class="way__item from">
                                                    <div class="way__item--time">
                                                        <span>{{selectedItem.depTime}}</span>
                                                        {{selectedItem.depDate}}
                                                    </div>
                                                    <div class="way__item--country">
                                                        <span>{{selectedItem.depCity.title}}</span>
                                                        {{selectedItem.depCity.code}}
                                                    </div>
                                                </div>
                                                <div class="way__item">
                                                    <div class="way__item--time">
                                                        <span>{{selectedItem.arriveTime}}</span>
                                                        {{selectedItem.arriveDate}}
                                                    </div>
                                                    <div class="way__item--country">
                                                        <span>{{selectedItem.arriveCity.title}}</span>
                                                        {{selectedItem.arriveCity.code}}
                                                    </div>
                                                </div>
                                            </div>
                                        </div>
                                    </div>
                                </div>
                            </div>
                            <div class="block_f" v-for="item in countPerson" style="padding: 25px;">
                                <h3>Person <span v-if="countPerson > 1" @click="countPerson--" style="cursor:pointer;"><svg xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink" xmlns:sketch="http://www.bohemiancoding.com/sketch/ns" width="15px" height="15px" viewBox="0 -5 32 32" version="1.1">
                                <title>delete</title>
                                <desc>Created with Sketch Beta.</desc>
                                <defs>

                                </defs>
                                <g id="Page-1" stroke="none" stroke-width="1" fill="none" fill-rule="evenodd" sketch:type="MSPage">
                                    <g id="Icon-Set" sketch:type="MSLayerGroup" transform="translate(-516.000000, -1144.000000)" fill="#000000">
                                        <path d="M538.708,1151.28 C538.314,1150.89 537.676,1150.89 537.281,1151.28 L534.981,1153.58 L532.742,1151.34 C532.352,1150.95 531.718,1150.95 531.327,1151.34 C530.936,1151.73 530.936,1152.37 531.327,1152.76 L533.566,1154.99 L531.298,1157.26 C530.904,1157.65 530.904,1158.29 531.298,1158.69 C531.692,1159.08 532.331,1159.08 532.725,1158.69 L534.993,1156.42 L537.232,1158.66 C537.623,1159.05 538.257,1159.05 538.647,1158.66 C539.039,1158.27 539.039,1157.63 538.647,1157.24 L536.408,1155.01 L538.708,1152.71 C539.103,1152.31 539.103,1151.68 538.708,1151.28 L538.708,1151.28 Z M545.998,1162 C545.998,1163.1 545.102,1164 543.996,1164 L526.467,1164 L518.316,1154.98 L526.438,1146 L543.996,1146 C545.102,1146 545.998,1146.9 545.998,1148 L545.998,1162 L545.998,1162 Z M543.996,1144 L526.051,1144 C525.771,1143.98 525.485,1144.07 525.271,1144.28 L516.285,1154.22 C516.074,1154.43 515.983,1154.71 515.998,1154.98 C515.983,1155.26 516.074,1155.54 516.285,1155.75 L525.271,1165.69 C525.467,1165.88 525.723,1165.98 525.979,1165.98 L525.979,1166 L543.996,1166 C546.207,1166 548,1164.21 548,1162 L548,1148 C548,1145.79 546.207,1144 543.996,1144 L543.996,1144 Z" id="delete" sketch:type="MSShapeGroup">
                                        </path>
                                    </g>
                                </g>
                                </svg></span></h3>
                                <div class="input_row">
                                    <div class="input">
                                        <input class="form_in" type="text" placeholder="NAME">
                                    </div>
                                    <div class="input">
                                        <input class="form_in" type="text" placeholder="SURNAME">
                                    </div>
                                    <div class="input">
                                        <input class="form_in" type="text" placeholder="PATRONYMIC">
                                    </div>
                                </div>
                                <div class="input_row" style="margin-top: 25px;">
                                    <div class="input">
                                        <input class="form_in" type="text" placeholder="BIRTHDAY">
                                    </div>
                                    <div class="input">
                                        <input class="form_in" type="text" placeholder="SEX">
                                    </div>
                                    <div class="input">
                                        <input class="form_in" type="text" placeholder="PASSPORT">
                                    </div>
                                </div>
                            </div>
                            <div class="btns" style="display:flex; gap: 15px">
                                <button class="btn" @click="pay(formatPrice(selectedItem.price), JSON.stringify(selectedItem))">Choose</button>
                                <button class="btn" @click="countPerson++">Add Person</button>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </main>
</template>

<style scoped>
.skeleton {
    background: #eee;
    background: linear-gradient(110deg, #ececec 8%, #f5f5f5 18%, #ececec 33%);
    border-radius: 5px;
    background-size: 200% 100%;
    animation: 1.5s shine linear infinite;
    display: block;
    width: 150px;
    height: 20px;
}

.form_in {
    height: 50px;
    border: 1px solid #dddddd;
    border-radius: 10px;
    padding-left: 15px;
    width: 100%;
}

.input_row {
    width: 100%;
    display: flex;
    justify-content: space-between;
}

.input {
    width: 30%;
}

h3 {
    font-weight: bold;
}

.block_f {
    display: flex;
    width: 100%;
    flex-direction: column;
}

@keyframes shine {
    to {
        background-position-x: -200%;
    }
}
</style>
